unit manipulator5dofunit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, ExtCtrls,
  StdCtrls, Spin;

type

  { TForm1 }

  TForm1 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    Button5: TButton;
    CheckBox1: TCheckBox;
    CheckBox2: TCheckBox;
    FloatSpinEdit1: TFloatSpinEdit;
    FloatSpinEdit2: TFloatSpinEdit;
    FloatSpinEdit3: TFloatSpinEdit;
    FloatSpinEdit4: TFloatSpinEdit;
    FloatSpinEdit5: TFloatSpinEdit;
    FloatSpinEdit6: TFloatSpinEdit;
    FloatSpinEdit7: TFloatSpinEdit;
    FloatSpinEdit8: TFloatSpinEdit;
    Image1: TImage;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Memo1: TMemo;
    Timer1: TTimer;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure CheckBox1Change(Sender: TObject);
    procedure CheckBox2Change(Sender: TObject);
    procedure Image1Click(Sender: TObject);
    procedure Image1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Label3Click(Sender: TObject);
    procedure Label7Click(Sender: TObject);
    procedure Memo1Change(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
  private
    { private declarations }
  public
    { public declarations }
  end;

var
  Form1: TForm1;

implementation

type
  tpoint = record
    x,y : double;
    b : array[0..5] of double;
    f : double;
  end;
  ppoint = ^tpoint;

  tcell = record
    n : integer;
    p : array[0..2000] of ppoint;
  end;
  pcell = ^tcell;

var
m : array[0..20, 0..20] of pcell;
gen : integer = 0;
saved : integer = 0;
lost : integer = 0;
ii, jj, kk : integer;
{$R *.lfm}

{ TForm1 }


function dist(var x,y:double):double;
  begin
    if y<60 then dist:=-0 - x
            else if x> -0 then dist:=y-60
                           else dist:=sqrt( (-0 - x)*(-0 - x) + (y-60)*(y-60));
  end;
  procedure sortit(var c:tcell);
    var i,j,k : integer;
    x : double;
    pp : ppoint;
    begin
      if c.n <=1 then exit;
      for j:=0 to c.n-2 do
        for i:=j downto 0 do begin
        if c.p[i]^.f<c.p[i+1]^.f then begin
          pp:=c.p[i];
          c.p[i]:=c.p[i+1];  // pointers are exchanged
          c.p[i+1]:=pp;
        end;
      end;
    end;
  procedure limit(var s,d:tcell);     //source = selected, dest = what should be filtered
    var i,j,k : integer;
        x,m : double;
    var diff : double = 0.2;
  begin
    if d.n<=1 then exit;
      i:=0;
    repeat
      x := 0;
      m:=0;
      for k:=1 to 5 do begin
          x:= abs(s.p[0]^.b[k]-d.p[i]^.b[k]);
          if x>m then m:=x;
        end;
      if m>diff then BEGIN
      if (i+1)=d.n then d.n:=d.n-1
      else begin
        d.p[i]:=d.p[d.n];
        d.n:=d.n-1;
      end;
      END else inc(i);
    until i>=d.n;
    if d.n=0 then d.n:=1;
  end;

procedure TForm1.Button1Click(Sender: TObject);
var
s : string;
x1,y1,a,a1 ,b10,b20, b1,h1,s1,b2,h2,s2, f,f1,m : double;
x,y,b : array [0..5] of double;
i,j,k,n, r1,r, ii,jj, lost,w,h : integer;
begin
 memo1.visible:=false;
 image1.visible:=true;
 image1.width := 750;
 i:=random(200)+56;
 j:=random(200)+56;
 k:=random(200)+56;
 n:=i*$10000+j*$100+k;
 image1.canvas.pen.color := n;
 image1.canvas.pen.width := 5;
 w:=750;
 m := 750/200;
 h:=image1.height;

 saved := 0;

 a1  := floatspinedit1.value;     //1. segment
 a   := floatspinedit2.value;     //other segments
 b10 := floatspinedit3.value;     //alpha1 minvalue
 h1  := floatspinedit4.value;     //alpha1 maxvalue
//  s1 := floatspinedit5.value;
 b20 := floatspinedit6.value;     //alphas minvalue
 h2  := floatspinedit7.value;     //alphas maxvalue
//  s2 := floatspinedit8.value;
x[0]:=0;
y[0]:=0;

 //n := round(((h1-b10)/s1+1)*((h2-b20)/s2+1));
repeat
 r := random(65536);
 b1 := b10+((h1-b10)*r)/65536;
 b[1] := b1;
 x[1]:= a1 * sin(b1);    //beta from the y axe...
 y[1]:= a1 * cos(b1);
 for i:=2 to 5 do begin
     r := random(65536);
  //   r2 := random(65536);
     b[i]:= b20+((h2-b20)*r)/65536;
     b1  := b1+ b[i];
     x[i]:= x[i-1] + a * sin(b1);
     y[i]:= y[i-1] + a * cos(b1);
   end;
 if ((x[5]>-25) and (x[5]<35) and (y[5]<75) and (y[5]>15)) or checkbox1.checked then begin
//   i:= round((x[5]+25)/3);      not recorded now
//   j:= round((y[5]-15)/3);
   f:=0;
   for r:=1 to 5 do begin     //feasibility
     f1:=dist(x[r],y[r]);     //if any of "dist" is negative, whole shape should be abandoned.
     if f1<0 then f1:=f1*100;
     f:=f+f1;
   end;
   if (f>0) or not(checkbox2.checked) then begin
      inc(saved);
      for r:=1 to 5 do begin
        image1.canvas.moveto(round((x[r-1])*m+ w div 2),h-round((y[r-1])*m)-133);
        image1.canvas.lineto(round((x[r  ])*m+ w div 2),h-round((y[r  ])*m)-133);
        image1.canvas.pen.color := image1.canvas.pen.color xor $FF00F0;
      end;
     end;
   end;
 until saved>0;

end;


procedure TForm1.Button2Click(Sender: TObject);
 var
s : string;
x1,y1,a,a1 ,b10,b20, b1,h1,s1,b2,h2,s2, f,f1 : double;
x,y,b : array [0..5] of double;
i,j,k,n, r1,r, lost : integer;
begin
  memo1.visible:=true;
  image1.visible:=false;
  timer1.enabled:= true;
//  image1.width := 77;
  //erase old data
    for i:=0 to 20 do
      for j:=0 to 20 do
        m[i,j]^.n := 0;
  lost := 0;
  gen := 0;
  saved := 0;

  memo1.lines.clear;
  a1  := floatspinedit1.value;
  a  := floatspinedit2.value;
  b10 := floatspinedit3.value;
  h1 := floatspinedit4.value;
//  s1 := floatspinedit5.value;
  b20 := floatspinedit6.value;
  h2 := floatspinedit7.value;
//  s2 := floatspinedit8.value;
x[0]:=0;
y[0]:=0;

  //n := round(((h1-b10)/s1+1)*((h2-b20)/s2+1));
repeat
  r := random(65536);
  b1 := b10+((h1-b10)*r)/65536;
  b[1] := b1;
  x[1]:= a1 * sin(b1);    //beta from the y axe...
  y[1]:= a1 * cos(b1);
  for i:=2 to 5 do begin
      r := random(65536);
   //   r2 := random(65536);
      b[i] := b20+((h2-b20)*r)/65536;
      b1 := b1+ b[i];
      x[i]:= x[i-1] + a * sin(b1);
      y[i]:= y[i-1] + a * cos(b1);
    end;
  if (x[5]>-25) and (x[5]<35) and (y[5]<75) and (y[5]>15) then begin
    i:= round((x[5]+25)/3);
    j:= round((y[5]-15)/3);
    f:=0;
    for r:=1 to 5 do begin
      f1:=dist(x[r],y[r]);     //if any of "dist" is negative, whole shape should be abandoned.
      if f1<0 then f1:=f1*128;
      f:=f+f1;
    end;
    if f>0 then begin
      n:=m[i,j]^.n;
      if n<2000 then begin
        inc(saved);
        m[i,j]^.p[n]^.x := x[5];
        m[i,j]^.p[n]^.y := y[5];
        m[i,j]^.p[n]^.f := f;
        for r:=1 to 5 do m[i,j]^.p[n]^.b[r] := b[r];
        m[i,j]^.n := n+1;
     //   s:=inttostr(i)+#9+inttostr(j);     now:drawing
     //   Memo1.lines.add(s);
      end else inc(lost);
      end;
    end;


  inc(gen);
until lost>10000;
//exit;
s:='End. Generated: '+inttostr(gen)+'  Saved: '+inttostr(saved)+'  Lost: '+inttostr(lost);
memo1.lines.add(s);
label7.caption := s;
// now sort and select along the main path
//the best of on the "i=20, j=18" position
 sortit(m[20,18]^);
  s:='Path smoothing ... ';
  memo1.lines.add(s);
for i:= 19 downto 0 do begin      //horizontally
   limit(m[i+1,18]^,m[i,18]^);
   sortit(m[i,18]^);               //continue to 2,18, extend to 0,18
   end;
for i:= 18 downto 0 do begin      //horizontally
   limit(m[2,i+1]^,m[2,i]^);
   sortit(m[2,i]^);               //the last cell is 2,0
   end;

// filtering of the neighbouring 2x2
s:='Horizontal smoothing ... ';
memo1.lines.add(s);
for i:= 20 downto 0 do begin      //horizontally
  limit(m[i,18]^,m[i,19]^);
  sortit(m[i,19]^);
  end;
for i:= 20 downto 0 do begin      //horizontally
  limit(m[i,19]^,m[i,20]^);
  sortit(m[i,20]^);
  end;
for i:= 20 downto 5 do begin      //horizontally
  limit(m[i,18]^,m[i,17]^);
  sortit(m[i,17]^);
  end;
for i:= 20 downto 5 do begin      //horizontally
  limit(m[i,17]^,m[i,16]^);
  sortit(m[i,16]^);
  end;
// right down
s:='Vertical smoothing ... ';
memo1.lines.add(s);
for i:= 18 downto 0 do begin      //vertically
   limit(m[2,i]^,m[1,i]^);
   sortit(m[1,i]^);
   end;
for i:= 18 downto 0 do begin      //vertically
   limit(m[1,i]^,m[0,i]^);
   sortit(m[0,i]^);
   end;
for i:= 18 downto 0 do begin      //vertically
   limit(m[2,i]^,m[3,i]^);
   sortit(m[3,i]^);
   end;
for i:= 18 downto 0 do begin      //vertically
   limit(m[3,i]^,m[4,i]^);
   sortit(m[4,i]^);
   end;
timer1.enabled:= false;
memo1.lines.clear;
// data on the trace is filtered. Hopfully some of them survived.
// if any, select the best and record into the memo
// upper rectangle (area)
  for i:=0 to 20 do
    for j:=20 downto 16 do begin
      n := m[i,j]^.n;
      if n>0 then begin
        if n>10 then n:=10;
        for k:=0 to n-1 do begin
          s := floattostr(m[i,j]^.p[k]^.x)+'; '+  floattostr(m[i,j]^.p[k]^.y) +'; ' ;
          for r:=1 to 5 do s := s+ floattostr(m[i,j]^.p[k]^.b[r])+'; ' ;
          Memo1.lines.add(s);
        end;
      end;
  end;
// lower rectangle
  for i:=0 to 4 do
    for j:=15 downto 0 do begin
      n := m[i,j]^.n;
      if n>0 then begin
        if n>10 then n:=10;
        for k:=0 to n-1 do begin
          s := floattostr(m[i,j]^.p[k]^.x)+'; '+  floattostr(m[i,j]^.p[k]^.y) +'; ' ;
          for r:=1 to 5 do s := s+ floattostr(m[i,j]^.p[k]^.b[r])+'; ' ;
          Memo1.lines.add(s);
       end;
      end;
  end;

end;

procedure TForm1.Button3Click(Sender: TObject);
begin
  image1.canvas.brush.Style:=bssolid;
  image1.canvas.brush.color:=clblack;
  image1.canvas.FillRect(0,0,image1.width-1,image1.Height-1);
  CheckBox2Change(Button3);
end;

procedure TForm1.Button4Click(Sender: TObject);
 var
s : string;
x1,y1,a,a1 ,b10,b20, b1,h1,s1,b2,h2,s2, f,f1, meritko : double;
x,y,b : array [0..5] of double;
i,j,k,n, w,h, r1,r, lost : integer;
begin
memo1.visible:=false;
image1.visible:=true;
image1.width := 750;
image1.canvas.pen.color := clwhite;
image1.canvas.pen.width := 1;
w:=750;
meritko := 750/200;
h:=image1.height;
  //erase old data
    for i:=0 to 20 do
      for j:=0 to 20 do
        m[i,j]^.n := 0;
  lost := 0;
  gen := 0;
  saved := 0;

  //memo1.lines.clear;
  a1  := floatspinedit1.value;
  a  := floatspinedit2.value;
  b10 := floatspinedit3.value;
  h1 := floatspinedit4.value;
//  s1 := floatspinedit5.value;
  b20 := floatspinedit6.value;
  h2 := floatspinedit7.value;
//  s2 := floatspinedit8.value;
x[0]:=0;
y[0]:=0;

  //n := round(((h1-b10)/s1+1)*((h2-b20)/s2+1));
repeat
  r := random(65536);
  b1 := b10+((h1-b10)*r)/65536;
  b[1] := b1;
  x[1]:= a1 * sin(b1);            //beta from the y axe...
  y[1]:= a1 * cos(b1);
  for i:=2 to 5 do begin
      r := random(65536);
   //   r2 := random(65536);
      b[i] := b20+((h2-b20)*r)/65536;
      b1 := b1+ b[i];
      x[i]:= x[i-1] + a * sin(b1);    //beta from the y axe...
      y[i]:= y[i-1] + a * cos(b1);
    end;
  if (x[5]>-25) and (x[5]<35) and (y[5]<75) and (y[5]>15) then begin
    i:= round((x[5]+25)/3);
    j:= round((y[5]-15)/3);
    f:=0;
    for r:=1 to 5 do begin
      f1:=dist(x[r],y[r]);      //if any of "dist" is negative, whole shape should be abandoned.
      if f1<0 then f1:=f1*128;
      f:=f+f1;
    end;
    if f>0 then begin
      n:=m[i,j]^.n;
      if n<333 then begin          //max. 2000
        inc(saved);
        m[i,j]^.p[n]^.x := x[5];
        m[i,j]^.p[n]^.y := y[5];
        m[i,j]^.p[n]^.f := f;
        for r:=1 to 5 do m[i,j]^.p[n]^.b[r] := b[r];
        m[i,j]^.n := n+1;
     //   s:=inttostr(i)+#9+inttostr(j);
     //   Memo1.lines.add(s);
     // draw pixel
     image1.canvas.Pixels[round((x[5])*meritko+ w div 2),h-round((y[5])*meritko)-133] := clWhite;
      end else inc(lost);
      end;
    end;


  inc(gen);
until lost>10;

s:='End. Generated: '+inttostr(gen)+'  Saved: '+inttostr(saved)+'  Lost: '+inttostr(lost);
label7.caption := s;

//exit;

end;

procedure TForm1.Button5Click(Sender: TObject);
var
s : string;
rx,ry,a,a1 ,b10,b20, b1,h1,s1,b2,h2,s2, f,f1, meritko : double;
x1,y1,b : array [0..5] of double;
i,j,k,n, w,h, r1,r, lost : integer;
begin
memo1.visible:=false;
image1.width := 750;
image1.canvas.brush.Style:=bssolid;
image1.canvas.brush.color:=clblack;
image1.canvas.FillRect(0,0,image1.width-1,image1.Height-1);
CheckBox2Change(nil);
//image1.canvas.pen.color := n;
//image1.canvas.pen.width := 5;
w:=750;
meritko := 750/200;
h:=image1.height;

a1  := floatspinedit1.value;
a  := floatspinedit2.value;
b10 := floatspinedit3.value;
h1 := floatspinedit4.value;
//  s1 := floatspinedit5.value;
b20 := floatspinedit6.value;
h2 := floatspinedit7.value;
//image1.canvas.Pixels[round((x[5])*meritko+ w div 2),h-round((y[5])*meritko)-133] := clWhite;
for i:=0 to 20 do
  for j:=0 to 20 do begin
    n := m[i,j]^.n;
      for k:=0 to n-1 do begin
     // draw pixel
     image1.canvas.Pixels[round((m[i,j]^.p[k]^.x)*meritko+ w div 2),
                        h-round((m[i,j]^.p[k]^.y )*meritko)-133] := clWhite;
      end;
    end;

end;

procedure TForm1.CheckBox1Change(Sender: TObject);
begin

end;

procedure TForm1.CheckBox2Change(Sender: TObject);
var
   h : integer;
   meritko: double;
begin
memo1.visible:=false;
image1.width := 750;
meritko := 750/200;
image1.canvas.brush.Style:=bssolid;
if checkbox2.checked then image1.canvas.brush.color:=clGray
                     else image1.canvas.brush.color:=clblack;
h:=image1.height;
//round((x)*meritko+ 375),h-round((y)*meritko)-133
image1.canvas.FillRect(5+375,
                      h,
                      round(60*750/200+375),
                      h-round(60*750/200)-133);

end;

procedure TForm1.Image1Click(Sender: TObject);
begin

end;

procedure TForm1.Image1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
 var
s : string;
rx,ry,a,a1 ,b10,b20, b1,h1,s1,b2,h2,s2, f,f1, meritko : double;
x1,y1{,b} : array [0..5] of double;
i,j,k,n, w,h, r1,r, lost : integer;
begin
//memo1.visible:=false;
//image1.width := 750;
i:=random(200)+56;
j:=random(200)+56;
k:=random(200)+56;
n:=i*$10000+j*$100+k;
image1.canvas.pen.color := n;
image1.canvas.pen.width := 5;
w:=750;
meritko := 750/200;
h:=image1.height;

a1  := floatspinedit1.value;
a  := floatspinedit2.value;
b10 := floatspinedit3.value;
h1 := floatspinedit4.value;
//  s1 := floatspinedit5.value;
b20 := floatspinedit6.value;
h2 := floatspinedit7.value;
//image1.canvas.Pixels[round((x[5])*meritko+ w div 2),h-round((y[5])*meritko)-133] := clWhite;
rx := (x - w div 2)/meritko;
ry := (h - (y + 133))/meritko;
i:= round((rx+25)/3);
j:= round((ry-15)/3);
if i<1 then exit;
if i>20 then exit;
if j<1 then exit;
if j>20 then exit;
if m[i,j]^.n > 1 then begin
    n:= m[i,j]^.n -1;
    m[i,j]^.n := n;
  //for r:=1 to 5 do m[i,j]^.p[n]^.b[r] := b[r];
  b1 := m[i,j]^.p[n]^.b[1];
  //b[1] := b1;
  x1[1]:= a1 * sin(b1);    //beta je od osy y...
  y1[1]:= a1 * cos(b1);
  for r:=2 to 5 do begin
  //    b[i] := b20+((h2-b20)*r)/65536;
      b1 := b1+ m[i,j]^.p[n]^.b[r];
      x1[r]:= x1[r-1] + a * sin(b1);    //beta je od osy y...
      y1[r]:= y1[r-1] + a * cos(b1);
    end;
  // vykreslit
  image1.canvas.moveto(round((x1[0])*meritko+ w div 2),h-round((y1[0])*meritko)-133);
  for r:=1 to 5 do begin
    image1.canvas.lineto(round((x1[r])*meritko+ w div 2),h-round((y1[r])*meritko)-133);
    image1.canvas.pen.color := image1.canvas.pen.color xor $FF00F0;
  end;

end;
end;

procedure TForm1.Label3Click(Sender: TObject);
begin

end;

procedure TForm1.Label7Click(Sender: TObject);
begin

end;

procedure TForm1.Memo1Change(Sender: TObject);
begin

end;

procedure TForm1.Timer1Timer(Sender: TObject);
var
  s : string;
begin
  // declaration was:  gen, saved, lost : integer;
  s:='Generated: '+inttostr(gen)+'  Saved: '+inttostr(saved)+'  Lost: '+inttostr(lost);
  memo1.lines.add(s);
//  Application.ProcessMessages;
end;

initialization
for ii:=0 to 20 do
  for jj:=0 to 20 do begin
    new(m[ii,jj]);    //cannot be in the fixed memory because of the program size
    m[ii,jj]^.n := 0;
      for kk:= 0 to 2000 do new(m[ii,jj]^.p[kk]);     //declares 2001*21*21 records
    end;                                          //sizeof(tpoint) = 9*8 = 72 bytes
end.                                                         //64 MB - not too much

